package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.DataSyncOut;
import com.sa.ibiz.demo.demo.service.DataSyncOutService;
import com.sa.ibiz.demo.demo.service.dto.DataSyncOutSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/datasyncout")
public class DataSyncOutResource
{
	@Autowired
	private DataSyncOutService service;


	@PostMapping(value = "/getDraft")
	public ResponseEntity<DataSyncOut> getDraft(@Validated @RequestBody DataSyncOut data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步发送队列[getDraft]操作发生错误","DataSyncOut","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<DataSyncOut> create(@Validated @RequestBody DataSyncOut data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步发送队列[create]操作发生错误","DataSyncOut",data.getDatasyncoutid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<DataSyncOut> get(@Validated @PathVariable String id){
		DataSyncOut data=new DataSyncOut();
		data.setDatasyncoutid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("数据同步发送队列[get]操作发生错误","DataSyncOut",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<DataSyncOut> checkKey(@Validated @RequestBody DataSyncOut data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步发送队列[checkKey]操作发生错误","DataSyncOut",data.getDatasyncoutid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<DataSyncOut> remove(@Validated @RequestBody DataSyncOut data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步发送队列[remove]操作发生错误","DataSyncOut",data.getDatasyncoutid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<DataSyncOut> update(@Validated @RequestBody DataSyncOut data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("数据同步发送队列[update]操作发生错误","DataSyncOut",data.getDatasyncoutid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<DataSyncOut>> searchDefaultPage(@Validated @RequestBody DataSyncOutSearchFilter filter){
		Page<DataSyncOut> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<DataSyncOut>> listDefault(@Validated @RequestBody DataSyncOutSearchFilter filter){
		List<DataSyncOut> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
